#include <psx.h>
#include <stdlib.h>
#include <string.h>

unsigned int prim_list[0x4000];
unsigned char filebuf[0x40000];

volatile int display_is_old = 1;

void prog_vblank_handler()
{
	display_is_old = 1;
}

int main()
{
	int y = 0;

    PSX_InitEx(PSX_INIT_NOBIOS);
		
	GsInit();
	GsSetList(prim_list);
	GsSetVideoMode(320, 240, VMODE_PAL);

	GsClearMem();
	GsSetDrawEnvSimple(0, 256, 320, 240);
	GsSetDispEnvSimple(0, 0);

	SetVBlankHandler(prog_vblank_handler);

	GsLoadFont(768, 0, 768, 128);
	while(GsIsWorking());

	while(1)
	{
		if(display_is_old)
		{
            printf("Frame Start\n");
			GsPrintFont(0, 0, "Hello World!!!");
            GsPrintFont(32, 32, "This is rendered using GPU :)");

			GsDrawList();
			while(GsIsWorking());
	
			y=!y;
			GsSetDrawEnvSimple(0, y?0:256, 320, 240);
			GsSetDispEnvSimple(0, y?256:0);
			display_is_old = 1;
            printf("Frame End\n");
		}
	}
}
